program TestAAHpMin;

{$APPTYPE CONSOLE}

uses
  AAHpMin in 'AAHpMin.pas',
  SysUtils;

var
  PtrArray : array [0..127] of pointer;
  i        : integer;

begin
  writeln('Testing AAHpMin...');
  try

  
    {at this point the replacement heap manager should be installed}
    Assert(IsMemoryManagerSet, 'Heap manager has not been replaced');

    writeln('allocate 128 pointers');
    for i := 0 to 127 do
      GetMem(PtrArray[i], Random(512) + 10);

    writeln('free every even element');
    for i := 0 to 127 do
      if not Odd(i) then begin
        FreeMem(PtrArray[i]);
        PtrArray[i] := nil;
      end;

    writeln('reallocate every odd element');
    for i := 0 to 127 do
      if Odd(i) then
        ReallocMem(PtrArray[i], Random(512) + 10);

    writeln('free every odd element');
    for i := 0 to 127 do
      if Odd(i) then begin
        FreeMem(PtrArray[i]);
        PtrArray[i] := nil;
      end;


    writeln('done');
  except
    on E : Exception do
      writeln(E.Message);
  end;
  write('Press Enter to close...');
  readln;
end.
